//------------------------------------------------------------
// NXT NicoSensor(color sensor) for ATtiny26L
// by Takuya Matsubara / Nico Corp.2007
// http://nicotak.com
//------------------------------------------------------------
#include <avr/io.h>
#include "softi2cs.h"
#include "adc.h"
#include "sio.h"	//debug


#define MYSLA  0x02    // slave addressiUltrasonicj

#define VALMIN 1	//Ultrasonic cm. min
#define VALMAX 254	//Ultrasonic cm. max
#define ADCMAX 1023 //AD count max
#define ADVMAX 460	//AVcc Volt. [x10mV]


void waitloop(long i)
{
    while(i-- > 0){
    }
}

int cnt_to_volt(int val)
{
	return((int)((ADVMAX * (long)val) >> 10));	// dɕϊ 0`460[x10mV]
}

#define LED_PORT   PORTB   // |[g
#define LED_DDR    DDRB    // o͐ݒ
#define LED_BIT    6       // rbgԍ
#define LED_ON     LED_PORT|=(1<<LED_BIT)
#define LED_OFF    LED_PORT&=~(1<<LED_BIT)


//http://www.hitechnic.com/index.html?lang=en-us&target=d18.html
unsigned char version[]=
{
	"00000001"
	"nico    "
	"color   "
};

#define COLOR_BLACK  0 // 0:
// 1:
#define COLOR_BLUE   2 // 2:
#define COLOR_CYAN   3 // 3:+
#define COLOR_GREEN  4 // 4:
// 5:+F
#define COLOR_YELLOW 6 // 6:F
// 7:F+
#define COLOR_RED    8   // 8:
// 9:+}[_
#define COLOR_PINK  10 //10:}[_
//11:+
//12:+
//13:+
//14:+
//15:+
//16:+}[_
//17:

#define CLED_OFF   3	//J[LED
#define CLED_RED   0	//J[LED
#define CLED_GREEN 1	//J[LED
#define CLED_BLUE  2	//J[LED
#define CLED_MAX   3	//J[LED
//------------------------------------------
void cled_set(char num)
{
	#define CLED_RBIT (1<<4)	//J[LEDrbg}XN
	#define CLED_GBIT (1<<1)	//J[LEDrbg}XN
	#define CLED_BBIT (1<<2)	//J[LEDrbg}XN
	#define CLED_PORT PORTA
	#define CLED_DDR  DDRA

	CLED_DDR  |=  (CLED_RBIT | CLED_GBIT | CLED_BBIT);
	CLED_PORT &= ~(CLED_RBIT | CLED_GBIT | CLED_BBIT);

	if(num==CLED_RED){
		CLED_PORT |= CLED_RBIT;
	}else if(num==CLED_GREEN){
		CLED_PORT |= CLED_GBIT;
	}else if(num==CLED_BLUE){
		CLED_PORT |= CLED_BBIT;
	}
}
//------------------------------------------
char mode_get(void)
{
	#define MODE_BIT 5
	char modenum;
	PORTA |= (0b111 << MODE_BIT);	//pullup PortA5`7
	modenum = (PINA >> MODE_BIT) ^ 0b111;

	return(modenum);
}
//------------------------------------------
void sendbyte(unsigned char ch)
{
    unsigned char ackdat;

	i2c_start();        // }X^̐ڑ҂
	i2c_read_byte();    // AhXM
	i2c_write_bit(I2C_ACK,1);    // ACKM

    i2c_write_byte(ch);  // lM
    ackdat = i2c_read_bit(1);
    i2c_sda_low();
}
//-------------------------------------------------
int main(void)
{
#define SENSE_RED   2	//xprbgVtg
#define SENSE_GREEN 0	//xprbgVtg
#define SENSE_BLUE  0	//xprbgVtg

	char color=0;
	char lednum=0;
    unsigned char slaw;
    unsigned char cmd;
    unsigned char cmd2;
	unsigned char r=128,g=128,b=128;

    LED_DDR |= (1<<LED_BIT);

    i2c_init();
	cled_set(CLED_OFF);
    ad_init(0);
	sio_init();
	LED_ON;
    waitloop(100000);
	sio_txstr("color");
	LED_OFF;
//    waitloop(100000);
    while(1){


		while(1)
		{
			i2c_start();        // }X^̐ڑ҂
			slaw = i2c_read_byte();    // AhXM
    
			if (slaw == MYSLA) {       // AhXv̏ꍇA
				i2c_write_bit(I2C_ACK,1);    // ACKM
				break;
			} else {                   // AhXsv̏ꍇA
				i2c_write_bit(I2C_NACK,1);    // NACKM
			}
		}

		LED_ON;

        cmd = i2c_read_byte();      // R}hM
        i2c_write_bit(I2C_ACK,1);   // ACKM

        if(cmd <= 0x17){
			//00-07H char Sensor version number
			//08-0FH char Manufacturer
			//10-17H char Sensor type
           sendbyte(version[cmd]);
		}else if(cmd <= 0x40){
			//18-3DH byte Not used
			//3E-3FH char Reserved
			//40H    byte Not used
		}else if(cmd == 0x41){
			//41H    byte Command
            cmd2 = i2c_read_byte();    // f[^Mî܂ܔjj
            i2c_write_bit(I2C_ACK,1);  // ACKM
		}else if(cmd == 0x42){
			//42H    byte Color number
            i2c_start();               // ʐMĊJ
            cmd2 = i2c_read_byte();    // AhXM
            i2c_write_bit(0,1);        // ACKM


			if(lednum==CLED_RED){
				r = (unsigned char)(ad_get() >> SENSE_RED);
			}else if(lednum==CLED_GREEN){
				g = (unsigned char)(ad_get() >> SENSE_GREEN);
			}else if(lednum==CLED_BLUE){
				b = (unsigned char)(ad_get() >> SENSE_BLUE);
			}

			if(r > g){
				if(r > b){
					color=COLOR_RED;
				}else{
					if(g > b){
						color=COLOR_YELLOW;
					}else{
						color=COLOR_BLUE;								}
				}
			}else{
				if(g > b){
					color=COLOR_GREEN;
				}else{
					if(r < b){
						color=COLOR_BLUE;
					}else{
						color=COLOR_CYAN;
					}
				}
			}

			i2c_write_byte(color);  // lM
            i2c_read_bit(1);
            i2c_sda_low();

			lednum++;
			if(lednum >= 3)
				lednum=0;

			cled_set(lednum);
		}else if(cmd == 0x43){
			//43H    byte Red reading
           sendbyte(r);
		}else if(cmd == 0x44){
			//44H    byte Green reading
           sendbyte(g);
		}else if(cmd == 0x45){
			//45H    byte Blue reading
           sendbyte(b);
		}else if(cmd <= 0x4B){
			//46-47H word Raw red sensor reading
			//48-49H word Raw green sensor reading
			//4A-4BH word Raw blue sensor reading
		}else if(cmd == 0x4C){
			//4CH    byte Color index number
           sendbyte(0);
		}else if(cmd <= 0x4F){
			//4DH    byte Normalized red reading
			//4EH    byte Normalized green reading
			//4FH    byte Normalized blue reading
           sendbyte(0);
        }
        i2c_stop();
		LED_OFF;

//		sio_txhex(cmd);	//debug
    }
}
